# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) Python Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
# pylint: disable=wrong-import-position

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ._patch import *  # pylint: disable=unused-wildcard-import


from ._models import (  # type: ignore
    AADProfileProperties,
    AwsCloudProfile,
    AwsCloudProfileUpdate,
    EndpointAccessResource,
    EndpointProperties,
    EndpointResource,
    ErrorAdditionalInfo,
    ErrorDetail,
    ErrorResponse,
    ExtensionResource,
    GenerateAwsTemplateRequest,
    IngressGatewayResource,
    IngressProfileProperties,
    InventoryProperties,
    InventoryResource,
    ListCredentialsRequest,
    ListIngressGatewayCredentialsRequest,
    ManagedProxyRequest,
    ManagedProxyResource,
    Operation,
    OperationDisplay,
    OperationStatusResult,
    ProxyResource,
    PublicCloudConnector,
    PublicCloudConnectorProperties,
    PublicCloudConnectorPropertiesUpdate,
    PublicCloudConnectorUpdate,
    RelayNamespaceAccessProperties,
    Resource,
    ServiceConfigurationProperties,
    ServiceConfigurationPropertiesPatch,
    ServiceConfigurationResource,
    ServiceConfigurationResourcePatch,
    SolutionConfiguration,
    SolutionConfigurationProperties,
    SolutionConfigurationPropertiesUpdate,
    SolutionConfigurationUpdate,
    SolutionSettings,
    SolutionTypeProperties,
    SolutionTypeResource,
    SolutionTypeSettings,
    SolutionTypeSettingsProperties,
    SystemData,
    TrackedResource,
    TrackedResourceUpdate,
)

from ._enums import (  # type: ignore
    ActionType,
    CloudNativeType,
    CreatedByType,
    HostType,
    Origin,
    ProvisioningState,
    ResourceProvisioningState,
    ServiceName,
    SolutionConfigurationStatus,
    Type,
)
from ._patch import __all__ as _patch_all
from ._patch import *
from ._patch import patch_sdk as _patch_sdk

__all__ = [
    "AADProfileProperties",
    "AwsCloudProfile",
    "AwsCloudProfileUpdate",
    "EndpointAccessResource",
    "EndpointProperties",
    "EndpointResource",
    "ErrorAdditionalInfo",
    "ErrorDetail",
    "ErrorResponse",
    "ExtensionResource",
    "GenerateAwsTemplateRequest",
    "IngressGatewayResource",
    "IngressProfileProperties",
    "InventoryProperties",
    "InventoryResource",
    "ListCredentialsRequest",
    "ListIngressGatewayCredentialsRequest",
    "ManagedProxyRequest",
    "ManagedProxyResource",
    "Operation",
    "OperationDisplay",
    "OperationStatusResult",
    "ProxyResource",
    "PublicCloudConnector",
    "PublicCloudConnectorProperties",
    "PublicCloudConnectorPropertiesUpdate",
    "PublicCloudConnectorUpdate",
    "RelayNamespaceAccessProperties",
    "Resource",
    "ServiceConfigurationProperties",
    "ServiceConfigurationPropertiesPatch",
    "ServiceConfigurationResource",
    "ServiceConfigurationResourcePatch",
    "SolutionConfiguration",
    "SolutionConfigurationProperties",
    "SolutionConfigurationPropertiesUpdate",
    "SolutionConfigurationUpdate",
    "SolutionSettings",
    "SolutionTypeProperties",
    "SolutionTypeResource",
    "SolutionTypeSettings",
    "SolutionTypeSettingsProperties",
    "SystemData",
    "TrackedResource",
    "TrackedResourceUpdate",
    "ActionType",
    "CloudNativeType",
    "CreatedByType",
    "HostType",
    "Origin",
    "ProvisioningState",
    "ResourceProvisioningState",
    "ServiceName",
    "SolutionConfigurationStatus",
    "Type",
]
__all__.extend([p for p in _patch_all if p not in __all__])  # pyright: ignore
_patch_sdk()
