# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) Python Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
# pylint: disable=wrong-import-position

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ._patch import *  # pylint: disable=unused-wildcard-import


from ._models import (  # type: ignore
    AzStackHCIClusterProperties,
    AzStackHCIFabricModelCustomProperties,
    CheckNameAvailabilityModel,
    CheckNameAvailabilityResponseModel,
    ConnectionDetails,
    DeploymentPreflightModel,
    DeploymentPreflightResource,
    DiskControllerInputs,
    EmailConfigurationModel,
    EmailConfigurationModelProperties,
    ErrorAdditionalInfo,
    ErrorDetail,
    ErrorModel,
    ErrorResponse,
    EventModel,
    EventModelCustomProperties,
    EventModelProperties,
    FabricAgentModel,
    FabricAgentModelCustomProperties,
    FabricAgentModelProperties,
    FabricModel,
    FabricModelCustomProperties,
    FabricModelProperties,
    FabricModelUpdate,
    FailoverJobModelCustomProperties,
    FailoverProtectedItemProperties,
    GroupConnectivityInformation,
    HealthErrorModel,
    HyperVMigrateFabricModelCustomProperties,
    HyperVToAzStackHCIDiskInput,
    HyperVToAzStackHCIEventModelCustomProperties,
    HyperVToAzStackHCINicInput,
    HyperVToAzStackHCIPlannedFailoverModelCustomProperties,
    HyperVToAzStackHCIPolicyModelCustomProperties,
    HyperVToAzStackHCIProtectedDiskProperties,
    HyperVToAzStackHCIProtectedItemModelCustomProperties,
    HyperVToAzStackHCIProtectedItemModelCustomPropertiesUpdate,
    HyperVToAzStackHCIProtectedNicProperties,
    HyperVToAzStackHCIRecoveryPointModelCustomProperties,
    HyperVToAzStackHCIReplicationExtensionModelCustomProperties,
    IdentityModel,
    InnerHealthErrorModel,
    JobModel,
    JobModelCustomProperties,
    JobModelCustomPropertiesAffectedObjectDetails,
    JobModelProperties,
    ManagedServiceIdentity,
    Operation,
    OperationDisplay,
    OperationStatus,
    PlannedFailoverModel,
    PlannedFailoverModelCustomProperties,
    PlannedFailoverModelProperties,
    PolicyModel,
    PolicyModelCustomProperties,
    PolicyModelProperties,
    PrivateEndpoint,
    PrivateEndpointConnection,
    PrivateEndpointConnectionProxy,
    PrivateEndpointConnectionProxyProperties,
    PrivateEndpointConnectionResponseProperties,
    PrivateLinkResource,
    PrivateLinkResourceProperties,
    PrivateLinkServiceConnection,
    PrivateLinkServiceConnectionState,
    PrivateLinkServiceProxy,
    ProtectedItemDynamicMemoryConfig,
    ProtectedItemJobProperties,
    ProtectedItemModel,
    ProtectedItemModelCustomProperties,
    ProtectedItemModelCustomPropertiesUpdate,
    ProtectedItemModelProperties,
    ProtectedItemModelPropertiesUpdate,
    ProtectedItemModelUpdate,
    ProxyResource,
    RecoveryPointModel,
    RecoveryPointModelCustomProperties,
    RecoveryPointModelProperties,
    RemotePrivateEndpoint,
    RemotePrivateEndpointConnection,
    ReplicationExtensionModel,
    ReplicationExtensionModelCustomProperties,
    ReplicationExtensionModelProperties,
    Resource,
    StorageContainerProperties,
    SystemData,
    TaskModel,
    TaskModelCustomProperties,
    TestFailoverCleanupJobModelCustomProperties,
    TestFailoverJobModelCustomProperties,
    TrackedResource,
    UserAssignedIdentity,
    VMwareFabricAgentModelCustomProperties,
    VMwareMigrateFabricModelCustomProperties,
    VMwareToAzStackHCIDiskInput,
    VMwareToAzStackHCIEventModelCustomProperties,
    VMwareToAzStackHCINicInput,
    VMwareToAzStackHCIPlannedFailoverModelCustomProperties,
    VMwareToAzStackHCIPolicyModelCustomProperties,
    VMwareToAzStackHCIProtectedDiskProperties,
    VMwareToAzStackHCIProtectedItemModelCustomProperties,
    VMwareToAzStackHCIProtectedItemModelCustomPropertiesUpdate,
    VMwareToAzStackHCIProtectedNicProperties,
    VMwareToAzStackHCIRecoveryPointModelCustomProperties,
    VMwareToAzStackHCIReplicationExtensionModelCustomProperties,
    VaultIdentityModel,
    VaultModel,
    VaultModelProperties,
    VaultModelUpdate,
)

from ._enums import (  # type: ignore
    ActionType,
    CreatedByType,
    HealthStatus,
    JobObjectType,
    JobState,
    ManagedServiceIdentityType,
    Origin,
    PrivateEndpointConnectionStatus,
    ProtectedItemActiveLocation,
    ProtectionState,
    ProvisioningState,
    RecoveryPointType,
    ReplicationVaultType,
    ResynchronizationState,
    TaskState,
    TestFailoverState,
    VMNicSelection,
    VMwareToAzureMigrateResyncState,
    VaultIdentityType,
)
from ._patch import __all__ as _patch_all
from ._patch import *
from ._patch import patch_sdk as _patch_sdk

__all__ = [
    "AzStackHCIClusterProperties",
    "AzStackHCIFabricModelCustomProperties",
    "CheckNameAvailabilityModel",
    "CheckNameAvailabilityResponseModel",
    "ConnectionDetails",
    "DeploymentPreflightModel",
    "DeploymentPreflightResource",
    "DiskControllerInputs",
    "EmailConfigurationModel",
    "EmailConfigurationModelProperties",
    "ErrorAdditionalInfo",
    "ErrorDetail",
    "ErrorModel",
    "ErrorResponse",
    "EventModel",
    "EventModelCustomProperties",
    "EventModelProperties",
    "FabricAgentModel",
    "FabricAgentModelCustomProperties",
    "FabricAgentModelProperties",
    "FabricModel",
    "FabricModelCustomProperties",
    "FabricModelProperties",
    "FabricModelUpdate",
    "FailoverJobModelCustomProperties",
    "FailoverProtectedItemProperties",
    "GroupConnectivityInformation",
    "HealthErrorModel",
    "HyperVMigrateFabricModelCustomProperties",
    "HyperVToAzStackHCIDiskInput",
    "HyperVToAzStackHCIEventModelCustomProperties",
    "HyperVToAzStackHCINicInput",
    "HyperVToAzStackHCIPlannedFailoverModelCustomProperties",
    "HyperVToAzStackHCIPolicyModelCustomProperties",
    "HyperVToAzStackHCIProtectedDiskProperties",
    "HyperVToAzStackHCIProtectedItemModelCustomProperties",
    "HyperVToAzStackHCIProtectedItemModelCustomPropertiesUpdate",
    "HyperVToAzStackHCIProtectedNicProperties",
    "HyperVToAzStackHCIRecoveryPointModelCustomProperties",
    "HyperVToAzStackHCIReplicationExtensionModelCustomProperties",
    "IdentityModel",
    "InnerHealthErrorModel",
    "JobModel",
    "JobModelCustomProperties",
    "JobModelCustomPropertiesAffectedObjectDetails",
    "JobModelProperties",
    "ManagedServiceIdentity",
    "Operation",
    "OperationDisplay",
    "OperationStatus",
    "PlannedFailoverModel",
    "PlannedFailoverModelCustomProperties",
    "PlannedFailoverModelProperties",
    "PolicyModel",
    "PolicyModelCustomProperties",
    "PolicyModelProperties",
    "PrivateEndpoint",
    "PrivateEndpointConnection",
    "PrivateEndpointConnectionProxy",
    "PrivateEndpointConnectionProxyProperties",
    "PrivateEndpointConnectionResponseProperties",
    "PrivateLinkResource",
    "PrivateLinkResourceProperties",
    "PrivateLinkServiceConnection",
    "PrivateLinkServiceConnectionState",
    "PrivateLinkServiceProxy",
    "ProtectedItemDynamicMemoryConfig",
    "ProtectedItemJobProperties",
    "ProtectedItemModel",
    "ProtectedItemModelCustomProperties",
    "ProtectedItemModelCustomPropertiesUpdate",
    "ProtectedItemModelProperties",
    "ProtectedItemModelPropertiesUpdate",
    "ProtectedItemModelUpdate",
    "ProxyResource",
    "RecoveryPointModel",
    "RecoveryPointModelCustomProperties",
    "RecoveryPointModelProperties",
    "RemotePrivateEndpoint",
    "RemotePrivateEndpointConnection",
    "ReplicationExtensionModel",
    "ReplicationExtensionModelCustomProperties",
    "ReplicationExtensionModelProperties",
    "Resource",
    "StorageContainerProperties",
    "SystemData",
    "TaskModel",
    "TaskModelCustomProperties",
    "TestFailoverCleanupJobModelCustomProperties",
    "TestFailoverJobModelCustomProperties",
    "TrackedResource",
    "UserAssignedIdentity",
    "VMwareFabricAgentModelCustomProperties",
    "VMwareMigrateFabricModelCustomProperties",
    "VMwareToAzStackHCIDiskInput",
    "VMwareToAzStackHCIEventModelCustomProperties",
    "VMwareToAzStackHCINicInput",
    "VMwareToAzStackHCIPlannedFailoverModelCustomProperties",
    "VMwareToAzStackHCIPolicyModelCustomProperties",
    "VMwareToAzStackHCIProtectedDiskProperties",
    "VMwareToAzStackHCIProtectedItemModelCustomProperties",
    "VMwareToAzStackHCIProtectedItemModelCustomPropertiesUpdate",
    "VMwareToAzStackHCIProtectedNicProperties",
    "VMwareToAzStackHCIRecoveryPointModelCustomProperties",
    "VMwareToAzStackHCIReplicationExtensionModelCustomProperties",
    "VaultIdentityModel",
    "VaultModel",
    "VaultModelProperties",
    "VaultModelUpdate",
    "ActionType",
    "CreatedByType",
    "HealthStatus",
    "JobObjectType",
    "JobState",
    "ManagedServiceIdentityType",
    "Origin",
    "PrivateEndpointConnectionStatus",
    "ProtectedItemActiveLocation",
    "ProtectionState",
    "ProvisioningState",
    "RecoveryPointType",
    "ReplicationVaultType",
    "ResynchronizationState",
    "TaskState",
    "TestFailoverState",
    "VMNicSelection",
    "VMwareToAzureMigrateResyncState",
    "VaultIdentityType",
]
__all__.extend([p for p in _patch_all if p not in __all__])  # pyright: ignore
_patch_sdk()
