# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
# pylint: disable=wrong-import-position

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ._patch import *  # pylint: disable=unused-wildcard-import


from ._models_py3 import (  # type: ignore
    AccessKeys,
    AccessPolicyAssignment,
    AccessPolicyAssignmentList,
    AccessPolicyAssignmentPropertiesUser,
    Cluster,
    ClusterList,
    ClusterPropertiesEncryption,
    ClusterPropertiesEncryptionCustomerManagedKeyEncryption,
    ClusterPropertiesEncryptionCustomerManagedKeyEncryptionKeyIdentity,
    ClusterUpdate,
    Database,
    DatabaseList,
    DatabasePropertiesGeoReplication,
    DatabaseUpdate,
    ErrorAdditionalInfo,
    ErrorDetail,
    ErrorDetailAutoGenerated,
    ErrorResponse,
    ErrorResponseAutoGenerated,
    ExportClusterParameters,
    FlushParameters,
    ForceLinkParameters,
    ForceLinkParametersGeoReplication,
    ForceUnlinkParameters,
    ImportClusterParameters,
    LinkedDatabase,
    ManagedServiceIdentity,
    Module,
    Operation,
    OperationDisplay,
    OperationListResult,
    OperationStatus,
    Persistence,
    PrivateEndpoint,
    PrivateEndpointConnection,
    PrivateEndpointConnectionListResult,
    PrivateLinkResource,
    PrivateLinkResourceListResult,
    PrivateLinkServiceConnectionState,
    ProxyResource,
    ProxyResourceAutoGenerated,
    RegenerateKeyParameters,
    Resource,
    ResourceAutoGenerated,
    Sku,
    SkuDetails,
    SkuDetailsList,
    SystemData,
    TrackedResource,
    UserAssignedIdentity,
)

from ._redis_enterprise_management_client_enums import (  # type: ignore
    AccessKeyType,
    AccessKeysAuthentication,
    ActionType,
    AofFrequency,
    ClusteringPolicy,
    CmkIdentityType,
    CreatedByType,
    DeferUpgradeSetting,
    EvictionPolicy,
    HighAvailability,
    Kind,
    LinkState,
    ManagedServiceIdentityType,
    Origin,
    PrivateEndpointConnectionProvisioningState,
    PrivateEndpointServiceConnectionStatus,
    Protocol,
    ProvisioningState,
    RdbFrequency,
    RedundancyMode,
    ResourceState,
    SkuName,
    TlsVersion,
)
from ._patch import __all__ as _patch_all
from ._patch import *
from ._patch import patch_sdk as _patch_sdk

__all__ = [
    "AccessKeys",
    "AccessPolicyAssignment",
    "AccessPolicyAssignmentList",
    "AccessPolicyAssignmentPropertiesUser",
    "Cluster",
    "ClusterList",
    "ClusterPropertiesEncryption",
    "ClusterPropertiesEncryptionCustomerManagedKeyEncryption",
    "ClusterPropertiesEncryptionCustomerManagedKeyEncryptionKeyIdentity",
    "ClusterUpdate",
    "Database",
    "DatabaseList",
    "DatabasePropertiesGeoReplication",
    "DatabaseUpdate",
    "ErrorAdditionalInfo",
    "ErrorDetail",
    "ErrorDetailAutoGenerated",
    "ErrorResponse",
    "ErrorResponseAutoGenerated",
    "ExportClusterParameters",
    "FlushParameters",
    "ForceLinkParameters",
    "ForceLinkParametersGeoReplication",
    "ForceUnlinkParameters",
    "ImportClusterParameters",
    "LinkedDatabase",
    "ManagedServiceIdentity",
    "Module",
    "Operation",
    "OperationDisplay",
    "OperationListResult",
    "OperationStatus",
    "Persistence",
    "PrivateEndpoint",
    "PrivateEndpointConnection",
    "PrivateEndpointConnectionListResult",
    "PrivateLinkResource",
    "PrivateLinkResourceListResult",
    "PrivateLinkServiceConnectionState",
    "ProxyResource",
    "ProxyResourceAutoGenerated",
    "RegenerateKeyParameters",
    "Resource",
    "ResourceAutoGenerated",
    "Sku",
    "SkuDetails",
    "SkuDetailsList",
    "SystemData",
    "TrackedResource",
    "UserAssignedIdentity",
    "AccessKeyType",
    "AccessKeysAuthentication",
    "ActionType",
    "AofFrequency",
    "ClusteringPolicy",
    "CmkIdentityType",
    "CreatedByType",
    "DeferUpgradeSetting",
    "EvictionPolicy",
    "HighAvailability",
    "Kind",
    "LinkState",
    "ManagedServiceIdentityType",
    "Origin",
    "PrivateEndpointConnectionProvisioningState",
    "PrivateEndpointServiceConnectionStatus",
    "Protocol",
    "ProvisioningState",
    "RdbFrequency",
    "RedundancyMode",
    "ResourceState",
    "SkuName",
    "TlsVersion",
]
__all__.extend([p for p in _patch_all if p not in __all__])  # pyright: ignore
_patch_sdk()
