# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) Python Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
# pylint: disable=wrong-import-position

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ._patch import *  # pylint: disable=unused-wildcard-import


from ._models import (  # type: ignore
    ApplicationServerConfiguration,
    ApplicationServerFullResourceNames,
    ApplicationServerVmDetails,
    CentralServerConfiguration,
    CentralServerFullResourceNames,
    CentralServerVmDetails,
    CreateAndMountFileShareConfiguration,
    DatabaseConfiguration,
    DatabaseServerFullResourceNames,
    DatabaseVmDetails,
    DeployerVmPackages,
    DeploymentConfiguration,
    DeploymentWithOSConfiguration,
    DiscoveryConfiguration,
    DiskConfiguration,
    DiskDetails,
    DiskSku,
    DiskVolumeConfiguration,
    EnqueueReplicationServerProperties,
    EnqueueServerProperties,
    ErrorAdditionalInfo,
    ErrorDefinition,
    ErrorDetail,
    ErrorResponse,
    ExternalInstallationSoftwareConfiguration,
    FileShareConfiguration,
    GatewayServerProperties,
    HighAvailabilityConfiguration,
    HighAvailabilitySoftwareConfiguration,
    ImageReference,
    InfrastructureConfiguration,
    LinuxConfiguration,
    LoadBalancerDetails,
    LoadBalancerResourceNames,
    ManagedRGConfiguration,
    MessageServerProperties,
    MountFileShareConfiguration,
    NetworkConfiguration,
    NetworkInterfaceResourceNames,
    OSConfiguration,
    OSProfile,
    Operation,
    OperationDisplay,
    OperationStatusResult,
    OsSapConfiguration,
    Resource,
    SAPApplicationServerInstance,
    SAPApplicationServerProperties,
    SAPAvailabilityZoneDetailsRequest,
    SAPAvailabilityZoneDetailsResult,
    SAPAvailabilityZonePair,
    SAPCentralServerInstance,
    SAPCentralServerProperties,
    SAPConfiguration,
    SAPDatabaseInstance,
    SAPDatabaseProperties,
    SAPDiskConfiguration,
    SAPDiskConfigurationsRequest,
    SAPDiskConfigurationsResult,
    SAPInstallWithoutOSConfigSoftwareConfiguration,
    SAPSizingRecommendationRequest,
    SAPSizingRecommendationResult,
    SAPSupportedResourceSkusResult,
    SAPSupportedSku,
    SAPSupportedSkusRequest,
    SAPVirtualInstance,
    SAPVirtualInstanceError,
    SAPVirtualInstanceIdentity,
    SAPVirtualInstanceProperties,
    ServiceInitiatedSoftwareConfiguration,
    SharedStorageResourceNames,
    SingleServerConfiguration,
    SingleServerCustomResourceNames,
    SingleServerFullResourceNames,
    SingleServerRecommendationResult,
    SkipFileShareConfiguration,
    SoftwareConfiguration,
    SshConfiguration,
    SshKeyPair,
    SshPublicKey,
    StartRequest,
    StopRequest,
    StorageConfiguration,
    StorageInformation,
    SystemData,
    ThreeTierConfiguration,
    ThreeTierCustomResourceNames,
    ThreeTierFullResourceNames,
    ThreeTierRecommendationResult,
    TrackedResource,
    UpdateSAPApplicationInstanceRequest,
    UpdateSAPCentralInstanceRequest,
    UpdateSAPDatabaseInstanceRequest,
    UpdateSAPVirtualInstanceProperties,
    UpdateSAPVirtualInstanceRequest,
    UserAssignedIdentity,
    VirtualMachineConfiguration,
    VirtualMachineResourceNames,
    WindowsConfiguration,
)

from ._enums import (  # type: ignore
    ActionType,
    ApplicationServerVirtualMachineType,
    CentralServerVirtualMachineType,
    CreatedByType,
    DiskSkuName,
    EnqueueReplicationServerType,
    FileShareConfigurationType,
    ManagedResourcesNetworkAccessType,
    NamingPatternType,
    OSType,
    Origin,
    SAPConfigurationType,
    SAPDatabaseScaleMethod,
    SAPDatabaseType,
    SAPDeploymentType,
    SAPEnvironmentType,
    SAPHealthState,
    SAPHighAvailabilityType,
    SAPProductType,
    SAPSoftwareInstallationType,
    SAPVirtualInstanceIdentityType,
    SAPVirtualInstanceState,
    SAPVirtualInstanceStatus,
    SapVirtualInstanceProvisioningState,
)
from ._patch import __all__ as _patch_all
from ._patch import *
from ._patch import patch_sdk as _patch_sdk

__all__ = [
    "ApplicationServerConfiguration",
    "ApplicationServerFullResourceNames",
    "ApplicationServerVmDetails",
    "CentralServerConfiguration",
    "CentralServerFullResourceNames",
    "CentralServerVmDetails",
    "CreateAndMountFileShareConfiguration",
    "DatabaseConfiguration",
    "DatabaseServerFullResourceNames",
    "DatabaseVmDetails",
    "DeployerVmPackages",
    "DeploymentConfiguration",
    "DeploymentWithOSConfiguration",
    "DiscoveryConfiguration",
    "DiskConfiguration",
    "DiskDetails",
    "DiskSku",
    "DiskVolumeConfiguration",
    "EnqueueReplicationServerProperties",
    "EnqueueServerProperties",
    "ErrorAdditionalInfo",
    "ErrorDefinition",
    "ErrorDetail",
    "ErrorResponse",
    "ExternalInstallationSoftwareConfiguration",
    "FileShareConfiguration",
    "GatewayServerProperties",
    "HighAvailabilityConfiguration",
    "HighAvailabilitySoftwareConfiguration",
    "ImageReference",
    "InfrastructureConfiguration",
    "LinuxConfiguration",
    "LoadBalancerDetails",
    "LoadBalancerResourceNames",
    "ManagedRGConfiguration",
    "MessageServerProperties",
    "MountFileShareConfiguration",
    "NetworkConfiguration",
    "NetworkInterfaceResourceNames",
    "OSConfiguration",
    "OSProfile",
    "Operation",
    "OperationDisplay",
    "OperationStatusResult",
    "OsSapConfiguration",
    "Resource",
    "SAPApplicationServerInstance",
    "SAPApplicationServerProperties",
    "SAPAvailabilityZoneDetailsRequest",
    "SAPAvailabilityZoneDetailsResult",
    "SAPAvailabilityZonePair",
    "SAPCentralServerInstance",
    "SAPCentralServerProperties",
    "SAPConfiguration",
    "SAPDatabaseInstance",
    "SAPDatabaseProperties",
    "SAPDiskConfiguration",
    "SAPDiskConfigurationsRequest",
    "SAPDiskConfigurationsResult",
    "SAPInstallWithoutOSConfigSoftwareConfiguration",
    "SAPSizingRecommendationRequest",
    "SAPSizingRecommendationResult",
    "SAPSupportedResourceSkusResult",
    "SAPSupportedSku",
    "SAPSupportedSkusRequest",
    "SAPVirtualInstance",
    "SAPVirtualInstanceError",
    "SAPVirtualInstanceIdentity",
    "SAPVirtualInstanceProperties",
    "ServiceInitiatedSoftwareConfiguration",
    "SharedStorageResourceNames",
    "SingleServerConfiguration",
    "SingleServerCustomResourceNames",
    "SingleServerFullResourceNames",
    "SingleServerRecommendationResult",
    "SkipFileShareConfiguration",
    "SoftwareConfiguration",
    "SshConfiguration",
    "SshKeyPair",
    "SshPublicKey",
    "StartRequest",
    "StopRequest",
    "StorageConfiguration",
    "StorageInformation",
    "SystemData",
    "ThreeTierConfiguration",
    "ThreeTierCustomResourceNames",
    "ThreeTierFullResourceNames",
    "ThreeTierRecommendationResult",
    "TrackedResource",
    "UpdateSAPApplicationInstanceRequest",
    "UpdateSAPCentralInstanceRequest",
    "UpdateSAPDatabaseInstanceRequest",
    "UpdateSAPVirtualInstanceProperties",
    "UpdateSAPVirtualInstanceRequest",
    "UserAssignedIdentity",
    "VirtualMachineConfiguration",
    "VirtualMachineResourceNames",
    "WindowsConfiguration",
    "ActionType",
    "ApplicationServerVirtualMachineType",
    "CentralServerVirtualMachineType",
    "CreatedByType",
    "DiskSkuName",
    "EnqueueReplicationServerType",
    "FileShareConfigurationType",
    "ManagedResourcesNetworkAccessType",
    "NamingPatternType",
    "OSType",
    "Origin",
    "SAPConfigurationType",
    "SAPDatabaseScaleMethod",
    "SAPDatabaseType",
    "SAPDeploymentType",
    "SAPEnvironmentType",
    "SAPHealthState",
    "SAPHighAvailabilityType",
    "SAPProductType",
    "SAPSoftwareInstallationType",
    "SAPVirtualInstanceIdentityType",
    "SAPVirtualInstanceState",
    "SAPVirtualInstanceStatus",
    "SapVirtualInstanceProvisioningState",
]
__all__.extend([p for p in _patch_all if p not in __all__])  # pyright: ignore
_patch_sdk()
